package  
{
	
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Tilemap;
	import net.flashpunk.masks.Grid;
	import net.flashpunk.FP;

	/**
	 * ...
	 * @author Seth A. Robinson
	 */
		
	public class Floors extends Entity
	{
		public var tiles:Tilemap;
		public var grid:Grid;
			
		public var TILE_SIZE:int;

		public function Floors(level:XML, width:int, height:int, TILES:*) 
		{

			//read data about this layer in - if your xml doesn't write this, you'd need to change this by hand..
			var tilesizex:int = level.@tilesizex;
			var tilesizey:int = level.@tilesizey;
			var sort:int = level.@sort;
			
			TILE_SIZE = tilesizex; 
			if (tilesizex != tilesizey)
			{
			  Error("Not handling this yet");
			
			}
			
			//figure out if this is about collision or not
			
			if (level.@collision == "yes")
			{
				trace("Located collision layer");
				//collision 
				mask = grid = new Grid( width ,  height, TILE_SIZE, TILE_SIZE);
				type = "solid";
				
				for each (var solid:XML in level[0].rect)
				{
					grid.setRect(solid.@x / TILE_SIZE, solid.@y / TILE_SIZE, solid.@w / TILE_SIZE, solid.@h / TILE_SIZE);
				}
			} else
			{
			// create and populate the tilemap from the level XML
				graphic = tiles = new Tilemap(TILES, width, height, TILE_SIZE, TILE_SIZE);
		
				for each (var tile:XML in level[0].tile)
				{
					tiles.setTile(tile.@x / TILE_SIZE, tile.@y / TILE_SIZE, tiles.getIndex(tile.@tx / TILE_SIZE, tile.@ty / TILE_SIZE));
				}
			}

			
			//override the "type" if it's set in the xml
			
			if (level.@type.length() > 0)
			{
				trace("Forcing type to " + level.@type);
				type = level.@type;
			}

		}
	}

}