package  
{
	import flash.utils.*;
	import net.flashpunk.*;
	import net.flashpunk.utils.*;
	import Player;
	import Level;
	import Particles;
	import com.greensock.easing.*
	import com.greensock.TweenMax;	
	
	/**
	 * ...
	 * @author Seth
	 */
	public class GameWorld extends World
	{
		public static var player:Player;
		public static var level:Level;
		public static var curLevel:int = 1;
		
		public function GameWorld() 
		{
			trace("Game world created");
			super();
			
			if (GC.DEBUG)
			{
				curLevel = 5;
			}
			Input.define("RESTART", Key.R);
		}
		 
		override public function update():void
		{
			super.update();
			
			if (Input.pressed("RESTART"))
			{
				trace("Pressed R");
				LoadLevel();
			}
		}
		
		public function ScheduleGraphic(timeSec:Number, bmp:Class, durationSec:Number)
		{
			TweenMax.delayedCall(timeSec, OnShowGraphic, [bmp, durationSec]);
		}
	
		public function ScheduleText(timeSec:Number, msg:String, durationSec:Number)
		{
			TweenMax.delayedCall(timeSec, OnShowText, [msg, durationSec]);
		}
	
		public function OnShowGraphic(fn:Class, timeSec:Number)
		{
			trace("Showing " + fn + " for " + timeSec);
			var ent:ShowSomething = new ShowSomething();
			
			add(ent);
			ent.SetImage(fn);
			ent.KillSelf(timeSec);
		}
		
			public function OnShowText(text:String, timeSec:Number)
		{
			trace("Showing " + text + " for " + timeSec);
			var ent:ShowSomething = new ShowSomething();
			
			add(ent);
			ent.SetText(text);
			ent.KillSelf(timeSec);
		}
		
		public function ScheduleSound(timeSec:Number, bmp:Class)
		{
			TweenMax.delayedCall(timeSec, OnShowSound, [bmp]);
		}
			
		public function OnShowSound(fn:Class)
		{
			var sfx:Sfx = new Sfx(fn);
			sfx.play();
		}
		
		public function LoadLevel():void
		{
			import flash.media.SoundMixer;
			SoundMixer.stopAll();
			TweenMax.killAll();
			FP.world.removeAll();
			
			ScheduleText(1, "Level " + curLevel, 3);
			add(new Particles);
			
			//load our level
			level = new Level(curLevel);
			this.add(level);
		}
		
		override public function begin():void 
		{
			FP.randomSeed = 283723; // getTimer();
			LoadLevel();
		}
		
	}

}