package  
{

	import flash.geom.Point;
	import net.flashpunk.graphics.*
	import net.flashpunk.tweens.misc.NumTween;
	import net.flashpunk.tweens.motion.LinearMotion;
	import net.flashpunk.utils.Ease;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.*;
	import com.greensock.easing.*
	import com.greensock.TweenMax;		
	import GameWorld;
	import Player;
	/**
	 * ...
	 * @author Seth
	 */
	public class Item extends Entity
	{
		[Embed(source = '../assets/RT_MapEd/maps/Level1/food1.png')]  public const FOOD1:Class;
		[Embed(source = '../assets/RT_MapEd/maps/Level1/food2.png')]  public const FOOD2:Class;
		[Embed(source = '../assets/RT_MapEd/maps/Level1/food3.png')]  public const FOOD3:Class;
		[Embed(source = '../assets/RT_MapEd/maps/Level1/food4.png')]  public const FOOD4:Class;
	
		[Embed(source = '../assets/RT_MapEd/maps/Level1/exit.png')]  public const IMAGE_EXIT:Class;
		
		static var soundEat1:Sfx = new Sfx(GC.SFX_EAT1);
		static var soundEat2:Sfx = new Sfx(GC.SFX_EAT2);
		static var soundEat3:Sfx = new Sfx(GC.SFX_EAT3);
		
		var triggerType:int;
		var foodType:int = -1;
		 public var image:Image = null;
		 
		public function Item() 
		{
		}

		public function SetText(msg:String):void
		{
			trace("Setting text to " + msg);
			var t:Text = new Text(msg);
			//t.align = "center";
			t.size = 28;
			layer = 5;
			triggerType = 0;
			graphic = t;
			
			//t.y = -10;
			//t.x = graphic.width / 2;
			
			t.centerOrigin();
	
		}
		
		public function SetTrigger(typeNum:int):void
		{
			trace("Setting trigger to " + typeNum);
			triggerType = typeNum;
			visible = false;
		}
		
		public function SetType(typeName:String, n:int):void
		{
		
			foodType = n;
			type = typeName;
			if (type == "food")
			{
				switch(n)
				{
					case 1:
						image = new Image(FOOD1);	
						break;
					case 2:
						image = new Image(FOOD2);	
						break;
					case 3:
						image = new Image(FOOD3);	
						
						break;
					case 4:
						image = new Image(FOOD4);	
						break;
					default:
						trace("Uh..");
							image = new Image(FOOD1);	
						break;
						
				}
				
	
			} else if (type == "exit")
			{
				image = new Image(IMAGE_EXIT);
			} else if (type == "text")
			{
				trace("Setting as text");
				return;
			} else if (type == "trigger")
			{
				trace("Setting as trigger");
				image = new Image(FOOD1);
			
			} else
			{
				trace("ERROR IN SETTYPE");
				return;
			}
			
			graphic = image;
			image.smooth = true;
		
			//centerOrigin();
			setHitbox(image.width, image.height);
		}

	
		public function OnTouched(e:Entity):void
		{
			
			if (type == "trigger")
			{
				trace("Touched trigger!");
						FP.world.remove(this);
			
						if (triggerType == 1)
						{
						(FP.world as GameWorld).ScheduleGraphic(4, GC.GFX_WITCH, 3);
						(FP.world as GameWorld).ScheduleSound(4, GC.SFX_ZORLAX1);
						}
						
						if (triggerType == 2)
						{
						(FP.world as GameWorld).ScheduleGraphic(4, GC.GFX_WITCH, 3);
						(FP.world as GameWorld).ScheduleSound(4, GC.SFX_ZORLAX2);
						}
						
						if (triggerType == 3)
						{
						(FP.world as GameWorld).ScheduleGraphic(4, GC.GFX_WITCH, 5);
						(FP.world as GameWorld).ScheduleSound(4, GC.SFX_ZORLAX4);
						}
						
							if (triggerType == 4)
						{
						(FP.world as GameWorld).ScheduleGraphic(8, GC.GFX_WITCH, 3);
						(FP.world as GameWorld).ScheduleSound(8, GC.SFX_ZORLAX_ORANGE);
						}
						
							if (triggerType == 6)
						{
						(FP.world as GameWorld).ScheduleGraphic(0, GC.GFX_WITCH, 15);
						(FP.world as GameWorld).ScheduleSound(1, GC.SFX_ZORLAX_END1);
							(FP.world as GameWorld).ScheduleGraphic(21, GC.GFX_WITCH, 20);
						(FP.world as GameWorld).ScheduleSound(22, GC.SFX_ZORLAX_END2);
						(FP.world as GameWorld).ScheduleGraphic(42, GC.GFX_ENDING, 20000);
						(FP.world as GameWorld).ScheduleSound(42, GC.SFX_SONG_WON);
					}
						
							if (triggerType == 7)
						{
						}
		
			return;
			}
			var r:int = FP.rand(3);
			trace(r);
			switch (r)
			{
				case 0: soundEat1.play(); break;
				case 1: soundEat2.play(); break;
				case 2: soundEat3.play(); break;
			}
			
			switch (foodType)
			{
				case 3:
					Player.getPlayer.OnGiveWeapon();
					break;
				
			}
			FP.world.remove(this);
			GameWorld.player.OnModSize(1.0);
		}
		public function OnAdvanceToNextLevel():void
		{
			FP.world.remove(this);
			GameWorld.curLevel = GameWorld.curLevel +1;
			(FP.world as GameWorld).LoadLevel();
			trace("Won level");
		}
		
		public function OnTouchedExit(e:Entity):void
		{
			(world as GameWorld).ScheduleSound(0, GC.SFX_SONG_FINISH);
			TweenMax.delayedCall(1.7, OnAdvanceToNextLevel);
		}
		
	}

}